local rs_loaded = false
local cbw_loaded = false
addHook("ThinkFrame", function()

	if (RingSlinger and not rs_loaded) then
		rs_loaded = true;
		
		print("Hi! I'm Spongebob!")
		
		RingSlinger.Skins["supersponge"] = {
			ammo = 35,--Maximum ammo.
			weapons = {RSWPN_SPLASH, RSWPN_SEEKER}--Main, offhand
		}
		
		RingSlinger.Skins["supersponge_gl"] = RingSlinger.Skins["supersponge"]
		RingSlinger.Skins["supersponge_ss"] = RingSlinger.Skins["supersponge"]
	end
	if (CBW_Battle and not cbw_loaded) then

		cbw_loaded = true
		
		print("Let's get to kara-tay!")
		
		local B = CBW_Battle

		--Now let's create our action.
		local BubbleSplashAction = function(mo,doaction)
		
			local player = mo.player
			
			--Now for some definitions:
			player.actiontext = "Bubble Blast"
			player.actionrings = 20
			player.action2text = nil
			player.action2rings = 0
			
			// Bubble Splash's attack phases.
			local INIT_PHASE = 0
			local SPIN_PHASE = 1
			local SHOOT_PHASE = 2
			
			if not B.CanDoAction(player) then player.actionstate = INIT_PHASE return end	
			
			// Spongebob is currently using the blower.
			if P_IsPowerupActive(player, SS_POWERUP_BLOWER) then
				// If it is active, do not do anything else!
				if (player.ssvars.blower.status != RB_STATUS_OFF)
				or (player.ssvars.blower.cooldown > 0)
				or (P_GetBlowerCount(player) > 0) then
					doaction = -1
				end
			// Spongebob is currently using the jellyfishing net.
			elseif P_IsPowerupActive(player, SS_POWERUP_NET) then
				// There's something in the net!
				if (P_GetNetCount(player) > 0) then
					doaction = -1
				end
			end
	
			// In the initial phase, check if the player is ready to enter the state.
			if (player.actionstate == INIT_PHASE) then
				if (doaction == 1) then
					player.actionstate = SPIN_PHASE
					player.actiontime = 0
					B.PayRings(player) 
					S_StartSound(mo,sfx_s3k3c)
				end
			end
			
			// Do a little spin before firing your bubbles.
			if (player.actionstate == SPIN_PHASE)
			
				player.ssvars.whirlpooling = false 	// we might be whirlpooling, so stop it.
			
				player.actiontime = $+1
				player.powers[pw_nocontrol] = 1
				
				mo.state = S_PLAY_TWINSPIN // Let's bring it around town!
				mo.momz = 0 // Set Z momentum to 0

				if (player.actiontime == 10) then 
					player.actionstate = 2 
					player.actiontime = 0 
				end
			end
			
			// Start firing!
			if (player.actionstate == SHOOT_PHASE) then
			
				player.actiontime = $+1
				
				// On the last second of player.actiontime, fire 8 different bubbles, in 8 different directions!
				if (player.actiontime == 3) then
		 			for i=1,8 do
					
						local bubble = P_SPMAngle(mo,MT_SUPERSPONGE_BUBBLEMISSILE,mo.angle-ANGLE_45*i-1,0)
						
						if not (bubble and bubble.valid) then
							continue // did the bubble disappear? oh well...
						end
						
						bubble.fuse = TICRATE/2
						bubble.scale = FixedMul(2*FRACUNIT, mo.scale)
					end
				end
				
				B.ApplyCooldown(player,TICRATE*3)
				
				mo.state = S_PLAY_FALL
				player.drawangle = mo.angle
				player.powers[pw_nocontrol] = 1
				
				if (player.actiontime == 3) then
					player.actionstate = 0 // Reset player state.
				end
			end
		end

		// ButtBounce Hook
		local ButtBounceCheck = function(n1,n2,plr,mo,atk,def,weight,hurt,pain,ground,angle,thrust,thrust2,collisiontype)
			
			local is_buttbouncing
			
			// Don't continue unless we're in pain or collisiontype has no interaction.
			if (pain[n1] or collisiontype <= 0) then
				return false
			end
			
			// Don't continue unless the first player is alive and butt-bouncing.
			if not (plr[n1] and plr[n1].valid and plr[n1].playerstate == PST_LIVE)
			or not (mo[n1].health)
			or not (mo[n1].state == S_PLAY_SSBNCE or mo[n1].state == S_PLAY_SSBNCE_END) then
				return false
			end
			
			// Set jump flag and jump count to 1.
			plr[n1].pflags = $|PF_JUMPED
			plr[n1].ssvars.jmpcount = 1
			
			P_SetObjectMomZ(mo[n1], 24*FRACUNIT, true)

			mo[n1].state = S_PLAY_JUMP
					
			return true
		end
		
		// Add MT_SPARRINGDUMMY to whitelist.
		if (supersponge_blower_whitelist[MT_SPARRINGDUMMY] == nil) then
			supersponge_blower_whitelist[MT_SPARRINGDUMMY] = 2
		end
		
		CBW_Battle.SkinVars["supersponge"] = {
			flags = SKINVARS_GUARD|SKINVARS_NOSPINSHIELD,
			weight = 50,
			special = BubbleSplashAction,
			func_priority_ext = nil,
			func_exhaust = nil,
			func_precollide = nil,
			func_collide = ButtBounceCheck
		}
		
		CBW_Battle.SkinVars["supersponge_gl"] = CBW_Battle.SkinVars["supersponge"]
		CBW_Battle.SkinVars["supersponge_ss"] = CBW_Battle.SkinVars["supersponge"]
	end
end)