// Supersponge Init Lua File

// I might as well initalize the freeslots here as well.
freeslot(
"MT_SUPERSPONGE_POWERUP", // Powerup Object
"MT_SUPERSPONGE_PICKUP", // Pickup Object
"MT_SUPERSPONGE_BALLOON", // Balloon Object
"MT_SUPERSPONGE_VACBOX", // Vacuum Hitbox
"MT_SUPERSPONGE_NETBOX", // Net Hitbox
"MT_SUPERSPONGE_BUBBLE",
"MT_SUPERSPONGE_FAKEMISSILE",
"MT_SUPERSPONGE_JELLYMISSILE",
"MT_SUPERSPONGE_BUBBLEMISSILE",
"MT_SUPERSPONGE_VORTEXBUBBLE",
"MT_SUPERSPONGE_BUBBLEPARTICLE",
"MT_SUPERSPONGE_CLAM",
"MT_SUPERSPONGE_SHRINKRAY",
"MT_SUPERSPONGE_PIE",
"SPR_SSDI", // Powerup Sprites
"SPR_SSD1", // Item Sprites
"SPR_SSD2", // Jellyfish, Water Bubble, Exploding Pie
"SPR_SSD3", // HUD Icons
"SPR_SSD4", // Visual FX - Balloon (Popped), Water Helmet
"SPR_SSD5", // Monitor Icon
"SPR_CL4M", // Clams
"SPR2_JNET", // Jellyfish Net Animation
"SPR2_BWND", // Bubble Wand Animation
"SPR2_F2RE", // Alternate Fire Animation
"SPR2_MZAP", // Shrink-Ray Zap
// SPR2_W2LK // Walking+Blinking
"SPR2_W3LK", // Walking W/ Blower
// SPR2_W4LK // Walking+Blinking W/ Blower
// SPR2_RUN2 // Running+Blinking
"SPR2_KRAB", // Krabby Patty Face
"SPR_W0P1", // Weapon Sprites [Normal]
"SPR_W0P2", // Weapon Sprites [Space]
"SPR_W0P3", // Weapon Sprites [Super]
"S_PLAY_SSBNCE",
"S_PLAY_SSBNCE_END",
"S_PLAY_SSCHOP",
"S_PLAY_SSCHOP2",
"S_PLAY_SSCHOP3",
"S_PLAY_SSCHOP4",
"S_PLAY_SSNET",
"S_PLAY_SSNET2",
"S_PLAY_SSNET3",
"S_PLAY_SSNET4",
"S_PLAY_SSGUN",
"S_PLAY_SSGUN2",
"S_PLAY_SSGUN3",
"S_PLAY_SSGUN4",
"S_PLAY_SSF2RE",
"S_PLAY_SSF2RE2",
"S_PLAY_SSF2RE3",
"S_PLAY_SSF2RE4",
"S_PLAY_SSWAND",
"S_PLAY_SSWAND2",
"S_PLAY_SSWAND3",
"S_PLAY_SSWAND4",
"S_PLAY_MZAP",
"S_PLAY_DRWN_END",
"S_PLAY_WALK_BLOWER",
"S_PLAY_KRAB",
"S_SUPERSPONGE_FAKECHOP",
"S_SUPERSPONGE_POWERUP",
"S_SUPERSPONGE_PICKUP",
"S_SUPERSPONGE_PICKUP_RESPAWN",
"S_SUPERSPONGE_BALLOON",
"S_SUPERSPONGE_BALLOON_POP",
"S_SUPERSPONGE_BALLOON_POP2",
"S_SUPERSPONGE_STRING",
"S_SUPERSPONGE_VACBOX",
"S_SUPERSPONGE_NETBOX",
"S_SUPERSPONGE_PARTICLE",
"S_SUPERSPONGE_BUBBLE",
"S_SUPERSPONGE_BUBBLE_INIT",
"S_SUPERSPONGE_FAKEPLAT",
"S_SUPERSPONGE_FAKEMISSILE",
"S_SUPERSPONGE_FAKEMISSILE_DEATH",
"S_SUPERSPONGE_JELLYMISSILE",
"S_SUPERSPONGE_BUBBLEMISSILE",
"S_SUPERSPONGE_BUBBLEMISSILE_SPLASH",
"S_SUPERSPONGE_VORTEXBUBBLE",
"S_SUPERSPONGE_CLAM_OUT",
"S_SUPERSPONGE_CLAM_FLAP1",
"S_SUPERSPONGE_CLAM_FLAP2",
"S_SUPERSPONGE_CLAM_STAND",
"S_SUPERSPONGE_CLAM_CENTER",
"S_SUPERSPONGE_CLAM_ATTACK",
"S_SUPERSPONGE_CLAM_SPIN",
"S_SUPERSPONGE_SHRINKRAY",
"S_SUPERSPONGE_PANTS",
"S_SUPERSPONGE_BLOWER",
"S_SUPERSPONGE_HELMET",
"S_SUPERSPONGE_SPATULA",
"S_SUPERSPONGE_TOKEN",
"S_SUPERSPONGE_SPRK",
"S_SUPERSPONGE_ICON1",
"S_SUPERSPONGE_ICON2",
"S_SUPERSPONGE_PIE",
"S_SUPERSPONGE_PIE_EXPLOSION",
"S_SUPERSPONGE_FAKEBUBBLE",
"S_SUPERSPONGE_FAKEBUBBLE_MEDIUM",
"S_SUPERSPONGE_SPATULA_ICON1",
"S_SUPERSPONGE_SPATULA_ICON2",
"S_SUPERSPONGE_QUICKSTER_ICON1",
"S_SUPERSPONGE_QUICKSTER_ICON2",
"S_SUPERSPONGE_SIGNPOST_OVERLAY",
"sfx_bubwnd", // bubble wand
"sfx_btbnce", // buttbounce
"sfx_krch1", // karate chop 1
"sfx_krch2", // karate chop 2
"sfx_sbelec", // electrocuted
"sfx_sbnet", // fishing net
"sfx_sbjely", // jelly launcher
"sfx_sbsray", // shink ray
"sfx_sbglas", // glasses pickup
"sfx_sbblnk", //  blinking
"sfx_sbwlk1", // step noise 1
"sfx_sbwlk2", // step noise 2
"sfx_sbwlk3", // boot step 1
"sfx_sbwlk4", // boot step 2
"sfx_sbvic1", // taunt 1 - "Victory Screech!"
"sfx_sbvic2", // taunt 2 - "Bring It Around Town"
"sfx_sbvic3", // taunt 3 - "Alright!"
"sfx_sbvic4", // taunt 4 - "Laughter"
"sfx_sbvic5", // taunt 5 - "Yipee"
"sfx_sbvic6", // taunt 6 - "I am Spongebob, the destroyer of evil!"
"sfx_sbvic7", // taunt 7 - "You can't fool me, Plankton!"
"sfx_sbvic8", // taunt 8 - "I'm ready" (repeating)
"sfx_sbvic9", // taunt 9 - "La la la la la" (Singing)
"sfx_sbvica", // taunt 10 - Let's try that again (laughter)
"sfx_sbspls", // water splashing
"sfx_sbdive", // diving pickup
"sfx_sbland", // landing noise
"sfx_sbreef", // reef blower
"sfx_sbspy", // disguise
"sfx_sbgold", // spatula pickup
"sfx_sbjar", // jellyfish jam pickup
"sfx_sbitem", // goal item pickup
"sfx_sbpkup", // item pickup
"sfx_sbskll", // skill pickup
"sfx_sbpie", // spongebob dropping pie
"sfx_sbta01", // 1 - i love bikini bottom
"sfx_sbta02", // 2 - i'm ready
"sfx_sbta03", // 3 - thanks
"sfx_sbta04", // 4 - pack some ice
"sfx_sbta05", // 5 - squidward
"sfx_sbta06", // 6 - lets try again
"sfx_sbta07", // 7 - i need water
"sfx_sbta08", // 8 - on my way
"sfx_sbta09", // 9 - i ripped my pants
"sfx_sbta10", // 10 - another great day together
"sfx_sbta11", // 11 - disgruntled hey
"sfx_sbta12", // 12 - hey guys
"sfx_sbta13", // 13 - like that's gonna happen
"sfx_sbta14", // 14 - like a calculator, you can count on it!
"sfx_sbta15", // 15 - happy birthday!
"sfx_sbvo01", // bonus clip 1 - aye aye captain
"sfx_sbvo02", // bonus clip 2 - f is for friends
"sfx_sbvo03", // bonus clip 3 - H-h-how ya doin?
"sfx_sbvo04", // bonus clip 4 - Imagination!
"sfx_sbvo05", // bonus clip 5 - It's not about winning, it's about fun!
"sfx_sbvo06", // bonus clip 6 - Krusty Krab Pizza
"sfx_sbvo07", // bonus clip 7 - Krusty Krab Pizza (Cont.)
"sfx_sbvo08", // bonus clip 8 - Have you finished those errands?
"sfx_sbvo09", // bonus clip 9 - Flappin' Flotsam!
"sfx_sbvo10", // bonus clip 10 - Is this the part where we start kicking?
"sfx_sbvo11", // bonus clip 11 - The best time to wear a striped sweater...
"sfx_sbvo12", // bonus clip 12 - Chocolate
"sfx_sbvo13", // bonus clip 13 - "D'ahhh! *dolphin noise*"
"sfx_sbvo14", // bonus clip 14 - Barnacles!
"sfx_sbvo15", // bonus clip 15 - Tartar Sauce!
"sfx_sbvo16", // bonus clip 16- You like krabby patties don't you Squidward?
"sfx_sbflut", // spongebob nose flute
"sfx_ssmcur", // supersponge menu cursor move
"sfx_ssmok", // supersponge menu confirmation 
"sfx_ssmsel", // supersponge menu select
"sfx_rbstrt", // reef blower starting
"sfx_rbrun", // reef blower running
"sfx_rbstop" // reef blower stopping
)

// If the supporting mod has not already freeslotted these sprites then freeslot it to prevent any errors.

if (_G["SPR2_OOF_"] == nil) then
	freeslot("SPR2_OOF_") 
end

if (_G["SPR2_FKIK"] == nil) then
	freeslot("SPR2_FKIK")
end

// Because you never know...
spr2defaults[SPR2_JNET] = SPR2_FIRE
spr2defaults[SPR2_BWND] = SPR2_FIRE
spr2defaults[SPR2_MZAP] = SPR2_STND
spr2defaults[SPR2_F2RE] = SPR2_FIRE
spr2defaults[SPR2_KRAB] = SPR2_WAIT

local count = 0

// SPR NAMES
local SPR_PANTS = 1
local SPR_BLWR = 2
local SPR_BLWR_SPACE = 3
local SPR_HELMET = 4

// SPR OVERLAY INDEXES
local INDEX_WALK = 2
local INDEX_RUN_ = 5
local INDEX_TRNS = 14
local INDEX_CNT1 = 33
local INDEX_JNET = 34
local INDEX_BWND = 35
local INDEX_NIGHTS_START = 16
local INDEX_NIGHTS_END = 21
local MAX_SPRITES = 41

// Mass freeslot the pants, blower, and space helmet as there are WAY too many sprite slots to list here
for i = 1, MAX_SPRITES, 1 do

	local tbl
	local prefix
	
	tbl = {
		[SPR_PANTS] = "P@", // Pants
		[SPR_BLWR] = "B#", // Blower (Normal)
		[SPR_BLWR_SPACE] = "B@", // Blower (Space)
		[SPR_HELMET] = "#L" // Space Helmet
	}
	
	if (i > 9) then
		prefix = "SPR_"
	else
		prefix = "SPR_0"
	end
	
	for x = 1, #tbl do
	
		// Never freeslot NIGHTS sprites for any of the overlays.
		if (i >= INDEX_NIGHTS_START and i <= INDEX_NIGHTS_END) then
			continue 
		end
		
		// Do not freeslot WALK, RUN_, JNET, and BWND sprites for the blower variants.
		if ((x == SPR_BLWR or x == SPR_BLWR_SPACE) 
		and (i == INDEX_WALK or i == INDEX_RUN_ or i == INDEX_JNET or i == INDEX_BWND)) then
			continue
		end
			
		count = $ + 1
		
		freeslot(prefix .. i .. tbl[x])
	end
	
	if (i != MAX_SPRITES) then continue end
end

// Captions
sfxinfo[sfx_btbnce].caption = "Butt bounce!"
sfxinfo[sfx_sbelec].caption = "Electric shock"
sfxinfo[sfx_sbnet].caption = "Net swoop"
sfxinfo[sfx_sbjely].caption = "Jelly launcher firing"
sfxinfo[sfx_sbsray].caption = "Shrink ray firing"
sfxinfo[sfx_krch1].caption = "Karate chop"
sfxinfo[sfx_krch2].caption = "Karate chop"
sfxinfo[sfx_bubwnd].caption = "Blowing a bubble"
sfxinfo[sfx_sbglas].caption = "Putting on glasses"
sfxinfo[sfx_sbblnk].caption = "Spongebob blinking"
sfxinfo[sfx_sbwlk1].caption = "Footstep" 
sfxinfo[sfx_sbwlk2].caption = "Footstep"
sfxinfo[sfx_sbwlk3].caption = "Creaky Footstep"
sfxinfo[sfx_sbwlk4].caption = "Creaky Footstep"
sfxinfo[sfx_sbspls].caption = "Hydration"
sfxinfo[sfx_sbdive].caption = "Slow breathing"
sfxinfo[sfx_sbland].caption = "Hitting the ground"
sfxinfo[sfx_sbreef].caption = "Blower revving"
sfxinfo[sfx_sbspy].caption = "Putting on disguise"
sfxinfo[sfx_sbgold].caption = "Sparkle"
sfxinfo[sfx_sbjar].caption = "Jar pickup"
sfxinfo[sfx_sbpkup].caption = "Item pickup"
sfxinfo[sfx_sbitem].caption = "Goal item pickup"
sfxinfo[sfx_sbskll].caption = "Skill item pickup"
sfxinfo[sfx_sbpie].caption = "Spongebob dropping pie"

// Taunts
sfxinfo[sfx_sbta01].caption = "I love bikini bottom!"
sfxinfo[sfx_sbta02].caption = "I'm ready!"
sfxinfo[sfx_sbta03].caption = "Gee...thanks!"
sfxinfo[sfx_sbta04].caption = "Better pack some ice!"
sfxinfo[sfx_sbta05].caption = "Hi Squidward!"
sfxinfo[sfx_sbta06].caption = "Let's try again!"
sfxinfo[sfx_sbta07].caption = "I need water..."
sfxinfo[sfx_sbta08].caption = "I'm on my way!"
sfxinfo[sfx_sbta09].caption = "Oops! I guess I ripped my pants again!"
sfxinfo[sfx_sbta10].caption = "Ready best friend?"
sfxinfo[sfx_sbta11].caption = "Hey..."
sfxinfo[sfx_sbta12].caption = "Hey guys!"
sfxinfo[sfx_sbta13].caption = "Like that's gonna happen!"
sfxinfo[sfx_sbta14].caption = "You can count on it!"
sfxinfo[sfx_sbta15].caption = "Happy birthday!"

// Victory Taunts
sfxinfo[sfx_sbvic1].caption = "Unintelligible screeching"
sfxinfo[sfx_sbvic2].caption = "And now it's time to..."
sfxinfo[sfx_sbvic3].caption = "Alright!"
sfxinfo[sfx_sbvic4].caption = "Spongebob laughing"
sfxinfo[sfx_sbvic5].caption = "Yipee!"
sfxinfo[sfx_sbvic6].caption = "I am...the destroyer of evil!"
sfxinfo[sfx_sbvic7].caption = "You can't fool me, Plankton!"
sfxinfo[sfx_sbvic8].caption = "I'm ready! I'm ready! I'm ready!"
sfxinfo[sfx_sbvic9].caption = "La, la, la, la, la, la!"
sfxinfo[sfx_sbvica].caption = "(Laughs), Let's try again!"

// Bonus Taunts
sfxinfo[sfx_sbvo01].caption = "Aye Aye Captain!"
sfxinfo[sfx_sbvo02].caption = "F is for Friends..."
sfxinfo[sfx_sbvo03].caption = "H-H-How ya doin?"
sfxinfo[sfx_sbvo04].caption = "Imagination..."
sfxinfo[sfx_sbvo05].caption = "It's not about winning..."
sfxinfo[sfx_sbvo06].caption = "Krusty Krab Pizza!"
sfxinfo[sfx_sbvo07].caption = "Krusty Krab Pizza!"
sfxinfo[sfx_sbvo08].caption = "Have you finished those errands?"
sfxinfo[sfx_sbvo09].caption = "Flappin' Flotsam!"
sfxinfo[sfx_sbvo10].caption = "Is this the part where..."
sfxinfo[sfx_sbvo11].caption = "A song about striped sweaters."
sfxinfo[sfx_sbvo12].caption = "Good afternoon, sir!"
sfxinfo[sfx_sbvo13].caption = "Dolphin chirping"
sfxinfo[sfx_sbvo14].caption = "Barnacles!"
sfxinfo[sfx_sbvo15].caption = "Tartar Sauce!"
sfxinfo[sfx_sbvo16].caption = "You like krabby patties?"

// Menu Sounds
sfxinfo[sfx_ssmcur].caption = "Selection"
sfxinfo[sfx_ssmok].caption = "Beep"
sfxinfo[sfx_ssmsel].caption = "Beep"

// Reef Blower Noises
sfxinfo[sfx_rbstrt].caption = "Blower starting"
sfxinfo[sfx_rbrun].caption = "Blower running"
sfxinfo[sfx_rbstop].caption = "Blower stopping"

mobjinfo[MT_SUPERSPONGE_POWERUP] = {
        doomednum = -1,
		health = 1,
        spawnstate = S_SUPERSPONGE_POWERUP,
        radius = 16*FRACUNIT,
        height = 32*FRACUNIT,
        dispoffset = 0,
        activesound = sfx_None,
        flags = MF_SPECIAL
}

mobjinfo[MT_SUPERSPONGE_PICKUP] = {
        doomednum = -1,
		health = 1,
        spawnstate = S_SUPERSPONGE_PICKUP,
		deathstate = S_SUPERSPONGE_PICKUP_RESPAWN,
        radius = 16*FRACUNIT,
        height = 32*FRACUNIT,
        dispoffset = 0,
        activesound = sfx_None,
        flags = MF_SPECIAL
}

mobjinfo[MT_SUPERSPONGE_BALLOON] = {
        doomednum = -1,
		health = 100,
        spawnstate = S_SUPERSPONGE_BALLOON,
		deathstate = S_SUPERSPONGE_BALLOON_POP,
        radius = 16*FRACUNIT,
        height = 48*FRACUNIT,
        dispoffset = 0,
        activesound = sfx_None,
		deathsound = sfx_s3k77,
        flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_SHOOTABLE
}

mobjinfo[MT_SUPERSPONGE_VACBOX] = {
        doomednum = -1,
		health = 100,
        spawnstate = S_SUPERSPONGE_VACBOX,
		speed = 0,
        radius = 16*FRACUNIT,
        height = 32*FRACUNIT,
        dispoffset = 0,
        activesound = sfx_None,
        flags = MF_NOGRAVITY|MF_SLIDEME|MF_SOLID
}

mobjinfo[MT_SUPERSPONGE_NETBOX] = {
        doomednum = -1,
		health = 100,
        spawnstate = S_SUPERSPONGE_NETBOX,
		speed = 0,
        radius = 32*FRACUNIT,
        height = 72*FRACUNIT,
        dispoffset = 0,
        activesound = sfx_None,
		mass = 0,
		damage = 0,
        flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

mobjinfo[MT_SUPERSPONGE_BUBBLE] = {
        doomednum = -1,
		health = 1,
        spawnstate = S_SUPERSPONGE_BUBBLE_INIT,
		deathstate = S_POP1,
		xdeathstate = S_POP1,
        radius = 16*FRACUNIT,
        height = 32*FRACUNIT,
        dispoffset = 0,
        activesound = sfx_None,
        flags = MF_SOLID|MF_NOGRAVITY|MF_SHOOTABLE|MF_RUNSPAWNFUNC
}

mobjinfo[MT_SUPERSPONGE_FAKEMISSILE] = {
        doomednum = -1,
		health = 1000,
        spawnstate = S_SUPERSPONGE_FAKEMISSILE,
		deathstate = S_SUPERSPONGE_FAKEMISSILE_DEATH,
		speed = 20*FRACUNIT,
        radius = 11*FRACUNIT,
        height = 8*FRACUNIT,
        dispoffset = 0,
        activesound = sfx_None,
		mass = 0,
		damage = 0,
        flags = MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY
}

mobjinfo[MT_SUPERSPONGE_JELLYMISSILE] = {
        doomednum = -1,
		health = 1000,
        spawnstate = S_SUPERSPONGE_JELLYMISSILE,
		deathstate = S_XPLD1,
		speed = 20*FRACUNIT,
        radius = 16*FRACUNIT,
        height = 32*FRACUNIT,
        dispoffset = 0,
		seesound = sfx_sbjely,
        activesound = sfx_None,
		mass = DMG_ELECTRIC,
		damage = 20,
        flags = MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY
}

mobjinfo[MT_SUPERSPONGE_BUBBLEMISSILE] = {
        doomednum = -1,
		health = 1000,
        spawnstate = S_SUPERSPONGE_BUBBLEMISSILE,
		deathstate = S_SUPERSPONGE_BUBBLEMISSILE_SPLASH,
		speed = 20*FRACUNIT,
        radius = 16*FRACUNIT,
        height = 32*FRACUNIT,
        dispoffset = 0,
		seesound = sfx_wepfir,
        activesound = sfx_None,
		deathsound = sfx_None,
		mass = DMG_WATER,
		damage = 20,
        flags = MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY
}

mobjinfo[MT_SUPERSPONGE_PIE] = {
        doomednum = -1,
		health = 1000,
        spawnstate = S_SUPERSPONGE_PIE,
		deathstate = S_SUPERSPONGE_PIE_EXPLOSION,
		speed = mobjinfo[MT_THROWNEXPLOSION].speed/4,
        radius = mobjinfo[MT_THROWNEXPLOSION].radius,
        height = mobjinfo[MT_THROWNEXPLOSION].height,
        dispoffset = 0,
		seesound = sfx_wepfir,
        activesound = sfx_None,
		mass = 100,
		damage = 1,
        flags = MF_NOBLOCKMAP|MF_MISSILE
}

mobjinfo[MT_SUPERSPONGE_VORTEXBUBBLE] = {
        doomednum = -1,
		health = 1,
        spawnstate = S_SUPERSPONGE_VORTEXBUBBLE,
		deathstate = S_SUPERSPONGE_VORTEXBUBBLE,
		speed = 2*FRACUNIT,
        radius = 8*FRACUNIT,
        height = 16*FRACUNIT,
        dispoffset = 0,
		seesound = sfx_None,
        activesound = sfx_None,
		mass = DMG_WATER,
		damage = 20,
        flags = MF_NOBLOCKMAP|MF_NOGRAVITY
}

mobjinfo[MT_SUPERSPONGE_BUBBLEPARTICLE] = {
        doomednum = -1,
		health = 1,
        spawnstate = S_MEDIUMBUBBLE,
		deathstate = S_NULL,
		speed = 8*FRACUNIT,
        radius = 4*FRACUNIT,
        height = 4*FRACUNIT,
        dispoffset = 0,
		seesound = sfx_None,
        activesound = sfx_None,
		mass = 16,
		damage = 0,
        flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOGRAVITY|MF_SCENERY
}

mobjinfo[MT_SUPERSPONGE_CLAM] = {
        doomednum = -1,
        spawnstate = S_SUPERSPONGE_CLAM_OUT,
		health = 1000,
		seestate = S_SUPERSPONGE_CLAM_STAND,
		meleestate = S_SUPERSPONGE_CLAM_FLAP1,
		deathstate = S_SUPERSPONGE_CLAM_SPIN,
		xdeathstate = S_SUPERSPONGE_CLAM_SPIN,
		speed = 8*FRACUNIT,
        radius = 8*FRACUNIT,
        height = 20*FRACUNIT,
		mass = 16,
		damage = 0,
        flags = MF_NOGRAVITY,
		raisestate = S_NULL
}

mobjinfo[MT_SUPERSPONGE_SHRINKRAY] = {
    doomednum = -1,
    spawnhealth = 1000,
    spawnstate = S_SUPERSPONGE_SHRINKRAY,
    speed = 8,
    radius = 16*FRACUNIT,
    height = 16*FRACUNIT,
    damage = 0,
    mass = 10,
    flags = MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT,
}